# overpass-api

[Git Repository](https://github.com/drolbr/Overpass-API)

[Language Documentation](https://wiki.openstreetmap.org/wiki/Overpass_API)

[Overpass QL](https://wiki.openstreetmap.org/wiki/Overpass_API/Overpass_QL)

## Endpoints

```
https://overpass-api.de/api/interpreter
http://overpass-api.de/api/interpreter
https://z.overpass-api.de/api/interpreter
https://overpass.kumi.systems/api/interpreter
https://lz4.overpass-api.de/api/interpreter
```

## Overpass-Turbo

[Link](https://overpass-turbo.eu/)

```
[out:json][timeout:60];
(
node[uic_ref=8000050];nwr[shop=ticket]["tickets:public_transport"!=no](around:500);
node[uic_ref=8000050];nwr[amenity=vending_machine][vending=public_transport_tickets](around:100);
);
out body center qt;
```

## URL Encoding

* URL encoding for e.g. browser

```
https://overpass-api.de/api/interpreter?data=
```

* URL encoding for curl

```
curl -X GET --location '<enter endpoint>' --header 'Content-Type: application/x-www-form-urlencoded' --data-urlencode 'data=<enter Overpass QL input>'
```

* URL encoding for browser
```
https://overpass-api.de/api/interpreter?data=<enter Overpass QL input>
```

## Wget

```
wget -O <result file> --post-file=<query file> <endpoint>
```

## Examples

### Use `Bounding Box` to limit output

* [zero-ware](./query/cli/bounding-box.txt)

### Use `Area` to limit output

* [train stations inside area VRB](query/cli/area-vrb-train-station.txt)
* [B&R inside area VRB](query/cli/area-vrb-bike-ride.txt)

### Use `Around` to limit output

* [train stations around coordinate](query/cli/around-coord-nwr.txt)
* [multiple features around UIC station code](query/cli/around-nwr-multiple.txt)
* [nodes around UIC station code](query/cli/around-node.txt)
* [nwr's for amenities around UIC station code](query/cli/around-nwr.txt)
* [nwr's for shops around UIC station code](query/cli/around-nwr-shop.txt)
